Problem statement: 

LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.

Rules and restrictions:

  1. You can only travel among N cities, represented by indexes from 0 to N-1. Initially, you are in the city indexed 0 on Monday.
  2. The cities are connected by flights. The flights are represented as a N*N matrix (not necessary symmetrical), called flights representing the airline status from the city i to the city j. If there is no flight from the city i to the city j, flights[i][j] = 0; Otherwise, flights[i][j] = 1. Also, flights[i][i] = 0 for all i.
  3. You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day and can only take flights on each week's Monday morning. Since flight time is so short, we don't consider the impact of flight time.
  4. For each city, you can only have restricted vacation days in different weeks, given an N*K matrix called days representing this relationship. For the value of days[i][j], it represents the maximum days you could take vacation in the city i in the week j.

You're given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.

Example 1:

  1. Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]]
  2. Output: 12
  3. Explanation:
    Ans = 6 + 3 + 3 = 12.
  4. One of the best strategies is:
  5. 1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day.
    (Although you start at city 0, we could also fly to and start at other cities since it is Monday.)
  6. 2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days.
  7. 3rd week : stay at city 2, and play 3 days and work 4 days.

Example 2:

  1. Input:flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]]
  2. Output: 3
  3. Explanation:
    Ans = 1 + 1 + 1 = 3.
  4. Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks.
    For each week, you only have one day to play and six days to work.
    So the maximum number of vacation days is 3.

Example 3:

  1. Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]]
  2. Output: 21
  3. Explanation:
    Ans = 7 + 7 + 7 = 21
  4. One of the best strategies is:
  5. 1st week : stay at city 0, and play 7 days.
  6. 2nd week : fly from city 0 to city 1 on Monday, and play 7 days.
  7. 3rd week : fly from city 1 to city 2 on Monday, and play 7 days.

Note:

  1. N and K are positive integers, which are in the range of [1, 100].
  2. In the matrix flights, all the values are integers in the range of [0, 1].
  3. In the matrix days, all the values are integers in the range [0, 7].
  4. You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won't be counted as vacation days.
  5. If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week.
  6. We don't consider the impact of flight hours towards the calculation of vacation days.

Solutions One: DFS(TLE)

First, I deploy DFS to solve this problem, find the maximum vacation days, finally this solution is TLE, because there is no any memory for the search, no prune, a lot of duplicated work.

The code is as following, the time complexity is O(N^K) since each city has K different permutations and there are N cities:

  1. class Solution {
  2. public:
  3. // this solution is TLE since it is less pruning, but it still works
  4. // time complexity is O(N^K)
  5. // N: the number of cities
  6. // K: the number of weeks
  7. // according to the problem statment there is no need for boundary check
  8. int maxVacationDays(vector<vector<int>>& flights, vector<vector<int>>& days) {
  9. int max_days = ;
  10. max_vocation_days(flights, days, , , , max_days);
  11. return max_days;
  12. }
  13. private:
  14. void max_vocation_days( vector<vector<int>>& flights,
  15. vector<vector<int>>& days,
  16. int city_idx,
  17. int week_idx,
  18. int cur_days,
  19. int& max_days){
  20. // DFS return condition
  21. if(week_idx == days[].size()){
  22. // update the final answer
  23. max_days = max(max_days, cur_days);
  24. return;
  25. }
  26. for(int i = ; i < flights[city_idx].size(); i++){
  27. // do i == city_idx check
  28. // get the optimal solution by comparing staying at the same city and traveling to another city
  29. if(i == city_idx || flights[city_idx][i] == ){
  30. max_vocation_days(flights, days, i, week_idx + , cur_days + days[i][week_idx], max_days);
  31. }
  32. }
  33. return;
  34. }
  35. };

Solution two: Dynamic programming(AC)

DP is the best solution for this problem, time complexity is O(N*K*K), K: # of weeks, N: # of cities

  • Allocate a K* N two dimension array dp: it means in week i, the best solution in city j.
  • Initalize dp[0][0...N-1]
  • The status formula is: dp[i][j] = max(dp[week][city], dp[week - 1][i] + days[city][week]);
  • The final answer is the maximum from dp[k - 1][0...N-1]
  1. class Solution {
  2. public:
  3. int maxVacationDays(vector<vector<int>>& flights, vector<vector<int>>& days) {
  4. int city_cnt = days.size();
  5. int week_cnt = days[].size();
  6. // DP array
  7. vector<vector<int>> dp(week_cnt, vector<int>(city_cnt, -));
  8. // DP initialize status
  9. // O(N)
  10. for(int i = ; i < city_cnt; i++){
  11. if(flights[][i] == || i == ){
  12. dp[][i] = days[i][];
  13. }
  14. }
  15. // DP , O(N*K*K)
  16. // start from week 1
  17. // for each city, find whic on can reach current city
  18. for(int week = ; week < week_cnt; week++){
  19. for(int city = ; city < city_cnt; city++){
  20. for(int i = ; i < city_cnt; i++){
  21. // dp[week - 1][i] != -1: this city has been visited
  22. if(dp[week - ][i] != - && (flights[i][city] == || i == city)){
  23. dp[week][city] = max(dp[week][city], dp[week - ][i] + days[city][week]);
  24. }
  25. }
  26. }
  27. }
  28. // return the maximum value from last week
  29. return *max_element(dp[week_cnt - ].begin(), dp[week_cnt - ].end());
  30. }
  31. };

568. Maximum Vacation Days的更多相关文章

  1. LeetCode 568. Maximum Vacation Days

    原题链接在这里:https://leetcode.com/problems/maximum-vacation-days/ 题目: LeetCode wants to give one of its b ...

  2. [LeetCode] 568. Maximum Vacation Days 最大化休假日

    LeetCode wants to give one of its best employees the option to travel among N cities to collect algo ...

  3. [LeetCode] Maximum Vacation Days 最大化休假日

    LeetCode wants to give one of its best employees the option to travel among N cities to collect algo ...

  4. LeetCode All in One题解汇总(持续更新中...)

    突然很想刷刷题,LeetCode是一个不错的选择,忽略了输入输出,更好的突出了算法,省去了不少时间. dalao们发现了任何错误,或是代码无法通过,或是有更好的解法,或是有任何疑问和建议的话,可以在对 ...

  5. leetcode 53 最大子序列之和(动态规划)

    思路:nums为给定的数组,动态规划: 设 一维数组:dp[i] 表示 以第i个元素为结尾的一段最大子序和. 1)若dp[i-1]小于0,则dp[i]加上前面的任意长度的序列和都会小于nums[i], ...

  6. All LeetCode Questions List 题目汇总

    All LeetCode Questions List(Part of Answers, still updating) 题目汇总及部分答案(持续更新中) Leetcode problems clas ...

  7. Leetcode problems classified by company 题目按公司分类(Last updated: October 2, 2017)

    All LeetCode Questions List 题目汇总 Sorted by frequency of problems that appear in real interviews. Las ...

  8. leetcode hard

    # Title Solution Acceptance Difficulty Frequency     4 Median of Two Sorted Arrays       27.2% Hard ...

  9. LeetCode All in One 题目讲解汇总(转...)

    终于将LeetCode的免费题刷完了,真是漫长的第一遍啊,估计很多题都忘的差不多了,这次开个题目汇总贴,并附上每道题目的解题连接,方便之后查阅吧~ 如果各位看官们,大神们发现了任何错误,或是代码无法通 ...

随机推荐

  1. javascript中的字符串编码、字符串方法详解

    js中的字符串是一种类数组,采用UTF-16编码的Unicode字符集,意味字符串的每个字符可用下标方式获取,而每个字符串在内存中都是一个16位值组成的序列.js对字符串的各项操作均是在对16位值进行 ...

  2. 用PHPExcel类读取excel文件的内容

    这里对PHPExcel类不做介绍,有兴趣的朋友可以自己查阅资料 在classes文件夹下有个PHPExcel.php文件,这个文件是这个类库的主要入口文件,在用之前,要引入这个类 其他的类,在此类中会 ...

  3. 我的日志文件java logger

    操作读取日志文件, 1.使用默认的日志文件,并验证默认级别 public void originalConfig() { Logger logger = Logger.getLogger(Logger ...

  4. webots自学笔记(六)实用控制器函数补充

    原创文章,来自"博客园,_阿龙clliu" http://www.cnblogs.com/clliu/,转载请注明原文章出处.       用Webots软件做机器人仿真时,可以编 ...

  5. 通过取父级for循环的i来理解闭包,iife,匿名函数

    在使用for循环的时候,假如需要在循环体中添加一个匿名函数处理其他的事情,那么,在这个匿名函数内,如果需要用到对应的i,因为闭包的缘故,循环体循环结束后才返回i,所以i最终为最后一次++的数值.   ...

  6. jq轮播图插件

    /* * 使用说明  *    *   1:需要提供一个标签   *   2:lis:图片的个数 *   3:轮播图的大小 width ,height *   4:图片的地址imgs[0].carou ...

  7. jdk源码剖析:Synchronized

    开启正文之前,先说一下源码剖析这一系列,就以"死磕到底"的精神贯彻始终,最少追踪到JVM指令(再往下C语言实现了). =========正文分割线===========  Sync ...

  8. ios坐标位置转换

    //ios常用坐标转换来处理一些下拉框队形的按钮的位置,我以最下面两个来进行一下个人的理解,不足之处多多见谅 - (CGPoint)convertPoint:(CGPoint)point toView ...

  9. MAT(Memory Analyzer Tool)使用心得

    起因:最近在跟踪产品的性能问题,期间主要问题体现在JVM的内存回收问题,使用MAT工具进行JVM内存分析(也可对android 的应用内存分析) 问题描述: 1.部分后端服务在运行一段时间后会突然年老 ...

  10. 通过virtualbox最小化安装centos 6.3后无法上网解决办法

    通过virtualbox最小化安装centos 6.3后无法上网解决办法 1.设置virtualbox的网络连接方式,如下图使用桥接方式,桥接的网卡为宿主正在上网的网卡,现在我是通过无线来上网的,所以 ...